/*
 * http://www.pabr.org/bricks/brickhid
 * Quick and dirty implementation of portions of the EV3 protocol.
 *
 * Copyright (c) 2014 pabr@pabr.org
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */

struct ev3_conn;

typedef enum { MOTA=1, MOTB=2, MOTC=4, MOTD=8 } ev3nos;
typedef enum { FREERUN=0, BRAKE=1 } ev3braking;

typedef signed long ev3p; // Steps or position in degrees
typedef int ev3s; // Speed in units of 10°/s ?

extern struct ev3_conn *ev3_connect(const char *localaddr, const char *ev3addr);

extern void ev3_close(struct ev3_conn *);

extern int ev3_sound_tone(struct ev3_conn *, int level, int hz, int ms);

extern int ev3_motor_speed(struct ev3_conn *, ev3nos, ev3s speed);
extern int ev3_motor_start(struct ev3_conn *, ev3nos);
extern int ev3_motor_stop(struct ev3_conn *, ev3nos, ev3braking);

extern int ev3_motor_step_speed(struct ev3_conn *conn, ev3nos,
				ev3s, ev3p up, ev3p cst, ev3p down,
				ev3braking);

extern int ev3_motor_set_position(struct ev3_conn *, ev3nos, ev3p);

extern int ev3_motor_reset(struct ev3_conn *, ev3nos);
extern int ev3_motor_read(struct ev3_conn *, int no, ev3s *, ev3p *);

extern int ev3_motor_clr_count(struct ev3_conn *, ev3nos);
extern int ev3_motor_get_count(struct ev3_conn *, int no, ev3p *);
extern int ev3_motor_moveto(struct ev3_conn *, ev3nos, int gain, ev3s, ev3p);

extern int ev3_output_ready(struct ev3_conn *, ev3nos);
